package de.laliluna.howto.beans;

import javax.faces.bean.ManagedBean;
import javax.faces.context.FacesContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Locale;
import java.util.ResourceBundle;

/**
 * Author: Sebastian Hennebrueder, http://www.laliluna.de
 * Date: 21.10.2009
 */
@ManagedBean
public class Localization {

	public String getHello(){
		// Loading the configured resource bundle
		FacesContext context = FacesContext.getCurrentInstance();

		ResourceBundle bundle = context.getApplication().getResourceBundle(context, "m");
		return bundle.getString("hello");
	}

	public String getGoodBye(){
		FacesContext context = FacesContext.getCurrentInstance();

		// loading a non configured resource bundle
		ResourceBundle bundle = ResourceBundle.getBundle("de.laliluna.howto.anotherbundle", context.getViewRoot().getLocale());

		return bundle.getString("goodbye");
	}
}
