package de.laliluna.howto.beans;

import de.laliluna.howto.model.Article;
import de.laliluna.howto.services.ArticleService;
import de.laliluna.howto.services.ServiceFactoryImp;
import java.util.Arrays;
import java.util.List;
import javax.faces.bean.ManagedBean;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;

@ManagedBean(name = "navigation")
public class Navigation {

	private Integer id;
	private ArticleService articleService = ServiceFactoryImp.getInstance().getService(ArticleService.class);

	public void setId(Integer id) {
		this.id = id;
	}

	public Integer getId() {
		return id;
	}

	public void editItem() {
		System.out.print("Editing Item with id " + id);
	}

	public List<Article> getArticles() {
		return articleService.findAll();
	}

	/**
	 * This method was introduced to play around with options to pass an ID to the bean.
	 * As long as we don't save this bean in a session scope or flash scope, this
	 * isn't possible and we need to extract the id from the request.
	 * @return
	 */
	public String getIdValue() {
		if (id != null) {
			return "Id from property: " + id;
		} else {

			ExternalContext context = FacesContext.getCurrentInstance().getExternalContext();
			String id = context.getRequestParameterMap().get("id");
			return "Id extracted from the request parameter " + id;
		}
	}

	public Article getArticle(){
			ExternalContext context = FacesContext.getCurrentInstance().getExternalContext();
			Integer id = Integer.parseInt(context.getRequestParameterMap().get("id"));
			return articleService.findById(id);
	}

	public String hello() {
		System.out.print("Entering hello");
		return Globals.SUCCESS;
	}
}
