package de.laliluna.howto.beans;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;
import javax.faces.application.Application;
import java.util.Locale;
import java.util.List;
import java.util.Iterator;
import java.util.ArrayList;
import java.io.Serializable;

/**
 * Bean stores value for the user session
 * Author: Sebastian Hennebrueder, http://www.laliluna.de
 * Date: 21.10.2009
 */
@ManagedBean
@SessionScoped
public class UserBean implements Serializable{
	private Locale locale;

	public Locale getLocale() {
		// we could load the locale from database her
		return locale == null ?  Locale.ENGLISH : locale; // assume English as default
	}

	public void setLocale(Locale locale) {
		System.out.println("setting locale to "+locale);
		this.locale = locale;
	}

	public List<Locale> getSupportedLocales(){
		Application application = FacesContext.getCurrentInstance().getApplication();
		Iterator<Locale> iterator = application.getSupportedLocales();
		List<Locale> result = new ArrayList<Locale>();
		while(iterator.hasNext())
			result.add(iterator.next());
		// I didn't include english in the supported locale list as it is specified as default locale
		result.add(application.getDefaultLocale());

		return result;
	}
}
