package de.laliluna.howto.components;

import de.laliluna.howto.services.MessageFactory;

import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;
import javax.faces.validator.FacesValidator;
import javax.faces.context.FacesContext;
import javax.faces.component.UIComponent;

/**
 * Validates if the email is one of ..@laliluna.de
 * Author: Sebastian Hennebrueder, http://www.laliluna.de
 * Date: 19.10.2009
 */
@FacesValidator("companyEmail")
public class CompanyEmailValidator implements Validator {

	public static final String VALIDATOR_ID = "companyEmail";

	public void validate(FacesContext facesContext, UIComponent uiComponent, Object value) throws ValidatorException {
		String email = (String) value;
		if (email != null) {
			email = email.toLowerCase();
			if (email.endsWith("@laliluna.de"))
				return;
		}
		throw new ValidatorException(MessageFactory.getMessage(facesContext, "validation_company_email"));
	}
}
