package de.laliluna.howto.services;

import de.laliluna.howto.model.Article;
import java.util.HashMap;
import java.util.Map;

public class ServiceFactoryImp implements ServiceFactory {

	private static ServiceFactory INSTANCE = new ServiceFactoryImp();

	private ServiceFactoryImp() {
	}

	public static ServiceFactory getInstance(){
		return INSTANCE;
	}

	private static Map<Class, Object> services = new HashMap<Class, Object>();

	static {
		ArticleService articleService = new ArticleServiceImpl();
		articleService.create(new Article(1, "foo", "This is foo's description"));
		articleService.create(new Article(2, "bar", "This is bar's description"));
		articleService.create(new Article(3, "bazz", "This is bazz's description"));

		services.put(ArticleService.class, articleService);
	}

	public <T> T  getService(Class<T> serviceInterface) {
		return (T) services.get(serviceInterface);
	}
}
