
package de.laliluna.howto.application;

import java.util.List;
import org.junit.Assert;
import org.junit.Test;

public class UrlAnalyserTest {

	@Test
	public void testNoFriendly(){
		UrlAnalyser analyser = new UrlAnalyser();
		String urls[] = {"/", "/foo.css", "/foo/bar.xhtml"};
		for (String url : urls) {

			Assert.assertNull(analyser.analyse(url));
		}
	}

	@Test
	public void testFriendly(){
		UrlAnalyser analyser = new UrlAnalyser();
		List<String> parts = analyser.analyse("/books");
		System.out.print(parts);
		Assert.assertNotNull(parts);
		Assert.assertEquals(1, parts.size());
		Assert.assertEquals("/books.xhtml", parts.get(0));

		parts = analyser.analyse("/books/");
		Assert.assertNotNull(parts);
		Assert.assertEquals(1, parts.size());
		Assert.assertEquals("/books.xhtml", parts.get(0));

		parts = analyser.analyse("/books/foo");
		Assert.assertNotNull(parts);
		Assert.assertEquals(2, parts.size());
		Assert.assertEquals("/books/foo.xhtml", parts.get(0));
		Assert.assertEquals("/books.xhtml", parts.get(1));

		parts = analyser.analyse("/books/foo/");
		Assert.assertNotNull(parts);
		Assert.assertEquals(1, parts.size());
		Assert.assertEquals("/books/foo.xhtml", parts.get(0));

		parts = analyser.analyse("/books");
		Assert.assertNotNull(parts);
		Assert.assertEquals(1, parts.size());
		Assert.assertEquals("/books.xhtml", parts.get(0));
		
	}


}
