package de.laliluna.examples.core;

import net.sourceforge.stripes.action.Resolution;
import net.sourceforge.stripes.action.After;
import net.sourceforge.stripes.action.ForwardResolution;
import net.sourceforge.stripes.controller.LifecycleStage;
import net.sourceforge.stripes.controller.Interceptor;
import net.sourceforge.stripes.controller.ExecutionContext;
import net.sourceforge.stripes.controller.Intercepts;
import de.laliluna.examples.model.User;
import de.laliluna.examples.model.Role;

/**
 * Mar 10, 2009
 *
 * @author Sebastian Hennebrueder
 */
@Intercepts(LifecycleStage.HandlerResolution)
public class SecurityInterceptor implements Interceptor{

	private User loadUser() {
// application has always this user
		User user = new User("Bert").addRole(new Role("sales")).addRole(new Role("human resources"));
		return user;
	}

	/* The interceptor simulates a security framework validating that the user is allowed to access
	* the ActionBean and the event method.
	* The implementation is slow, nonsense and just illustrates the idea
	*
	* @return a resolution pointing to page showing an authorize error message
	*/
	public Resolution intercept(ExecutionContext executionContext) throws Exception {
		Resolution resolution = executionContext.proceed();

		User user = loadUser();
		RequireRole annotation = executionContext.getHandler().getAnnotation(RequireRole.class);
		if (annotation != null){
			boolean canAccess = true;
			for (String role : annotation.value()) {
				if (!user.containsRole(role)){
					canAccess=false;
					break;
				}

			}
			if (! canAccess)
				return new ForwardResolution("/access_denied.jsp");
		}

		return resolution;
	}
}
