package de.laliluna.example.components;

import org.apache.tapestry5.annotations.Parameter;
import org.apache.tapestry5.annotations.BeginRender;
import org.apache.tapestry5.ioc.annotations.Inject;
import de.laliluna.example.security.SecurityService;
import de.laliluna.example.security.ApplicationUser;

/**
 * Author: Sebastian Hennebrueder, http://www.laliluna.de
 * Date: 05.08.2009
 */
public class HasRight {
	@Parameter(required = true, defaultPrefix = "literal")
	private String right;

	@Inject
	private SecurityService securityService;

	@BeginRender
	boolean checkAccess() {
		ApplicationUser user = securityService.getUser();
		return (user != null && user.hasRight(right));
	}
}
