package de.laliluna.example.components;

import org.apache.tapestry5.annotations.Parameter;
import org.apache.tapestry5.annotations.Environmental;
import org.apache.tapestry5.BindingConstants;
import org.apache.tapestry5.RenderSupport;
import org.apache.tapestry5.MarkupWriter;

/**
 * Author: Sebastian Hennebrueder, http://www.laliluna.de
 * Date: 10.08.2009
 */
public class Toggle {
	/**
	 * The target HTML element to toggle
	 */
	@Parameter(required = true, defaultPrefix = BindingConstants.LITERAL)
	private String targetId;

	/**
	 * The component id
	 */
	@Parameter(value = "prop:componentResources.id", defaultPrefix = BindingConstants.LITERAL)
	private String clientId;

	/**
	 * Unique id calculated by Tapestry
	 */
	private String calculatedClientId;

	@Environmental
	private RenderSupport renderSupport;

	void setupRender() {
		calculatedClientId = renderSupport.allocateClientId(clientId);
	}

	void beginRender(MarkupWriter writer) {
		writer.element("div", "id", calculatedClientId);
	}

	void afterRender(MarkupWriter writer) {
		writer.end();
		// script to hide target div initially and to register a click event listener on the first div
		renderSupport.addScript("$('%s').hide();$('%s').observe('mouseover', function(event){ event.element().setStyle({cursor:'pointer'});" +
				"});Event.observe('%s', 'click', function(event) {$('%s').toggle();});",
				targetId, calculatedClientId, calculatedClientId, targetId);
	}
}
