package de.laliluna.example.model;

import java.io.Serializable;

/**
 * Author: Sebastian Hennebrueder, http://www.laliluna.de
 * Date: 10.08.2009
 */
public class Article extends AbstractModel implements Serializable{

	private Integer id;
	private String name;
	private String description;

	public Article() {
	}

	public Article(Integer id, String name, String description) {
		this.id = id;
		this.name = name;
		this.description = description;
	}

	@Override
	public String toString() {
		final StringBuilder sb = new StringBuilder();
		sb.append("Article");
		sb.append("{id=").append(id);
		sb.append(", name='").append(name).append('\'');
		sb.append(", description='").append(description).append('\'');
		sb.append('}');
		return sb.toString();
	}

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public Object clone() {
		return new Article(id, name, description);
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}


}
