package de.laliluna.example.model;

import org.apache.tapestry5.ioc.annotations.Inject;

/**
 * Represents a phone number
 * Author: Sebastian Hennebrueder, http://www.laliluna.de
 * Date: 06.08.2009
 */
public class Phone {
	private String countryCode;
	private String areaPrefix;
	private String code;

	@Inject
	public Phone() {
	}

	public Phone(String countryCode, String areaPrefix, String code) {
		this.countryCode = countryCode;
		this.areaPrefix = areaPrefix;
		this.code = code;
	}

	@Override
	public String toString() {
		final StringBuilder sb = new StringBuilder();
		sb.append("Phone: ");
		sb.append(countryCode).append(" / ");
		sb.append(areaPrefix).append(" / ");
		sb.append(code);
		return sb.toString();
	}

	public String getCountryCode() {
		return countryCode;
	}

	public void setCountryCode(String countryCode) {
		this.countryCode = countryCode;
	}

	public String getAreaPrefix() {
		return areaPrefix;
	}

	public void setAreaPrefix(String areaPrefix) {
		this.areaPrefix = areaPrefix;
	}

	public String getCode() {
		return code;
	}

	public void setCode(String code) {
		this.code = code;
	}
}
