package de.laliluna.example.pages.input;

import org.apache.tapestry5.validator.AbstractValidator;
import org.apache.tapestry5.Field;
import org.apache.tapestry5.ValidationException;
import org.apache.tapestry5.MarkupWriter;
import org.apache.tapestry5.services.FormSupport;
import org.apache.tapestry5.ioc.MessageFormatter;

/**
 * Checksif the user inputs foo
 * Author: Sebastian Hennebrueder, http://www.laliluna.de
 * Date: 06.08.2009
 */
public class FooValidator extends AbstractValidator<Void, String> {
	public FooValidator() {
		super(null, String.class, "foo-not-allowed");
	}

	public void validate(Field field, Void constraintValue, MessageFormatter formatter, String value)
			throws ValidationException {
		if ("foo". equals(value))
			throw new ValidationException(buildMessage(formatter, field, constraintValue));
	}

	private String buildMessage(MessageFormatter formatter, Field field, Void constraintValue) {
		return formatter.format(constraintValue, field.getLabel());
	}

	public void render(Field field, Void constraintValue, MessageFormatter formatter, MarkupWriter writer,
										 FormSupport formSupport) {
		formSupport.addValidation(field, "foo", buildMessage(formatter, field, constraintValue), null);
	}
}

