package de.laliluna.example.security;

/**
 * Stores the user object of the loggin user
 * User: hennebrueder
 * Date: 05.08.2009
 */
public class SecurityContextHolder {
	private static ThreadLocal<ApplicationUser> applicationUserThreadLocal = new ThreadLocal<ApplicationUser>();

	private SecurityContextHolder(){}

	public static void setUser(ApplicationUser user){
		applicationUserThreadLocal.set(user);
	}

	public static ApplicationUser getUser(){
		return applicationUserThreadLocal.get();
	}

	public static void clean() {
		applicationUserThreadLocal.remove();
	}
}
