package de.laliluna.example.services;

import org.apache.tapestry5.ioc.annotations.Scope;
import org.apache.tapestry5.ioc.ScopeConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.List;
import java.util.ArrayList;
import java.util.Collections;

/**
 * User: hennebrueder
 * Date: 05.08.2009
 */
public class CountryServiceImpl implements CountryService {
	private static List<String> countrynames;

	private static String[][] countries = {
						// ISO DE-name, en-name, es-name, fr-name, it-name
					 {"AF","Andorra","Andorra"},
	{"AD","Vereinigte Arabische Emirate","United Arab Emirates","Emiratos rabes Unidos","mirats arabes unis","Emirati arabi uniti"},
	{"AE","Afghanistan","Afghanistan"},
	{"AG","Antigua und Barbuda","Antigua and Barbuda"},
	{"AI","Anguilla","Anguilla"},
	{"AL","Albanien","Albania"},
	{"AM","Armenien","Armenia"},
	{"AN","Niederlndische Antillen","Netherlands Antilles"},
	{"AO","Angola","Angola"},
	{"AQ","Antarktis","Antarctica"},
	{"AR","Argentinien","Argentina"},
	{"AS","Amerikanisch-Samoa","American Samoa"},
	{"AT","sterreich","Austria"},
	{"AU","Australien","Australia"},
	{"AW","Aruba","Aruba"},
	{"AZ","Aserbaidschan","Azerbaijan"},
	{"BA","Bosnien und Herzegowina","Bosnia and Herzegovina","Bosnia y Hercegovina"},
	{"BB","Barbados","Barbados"},
	{"BD","Bangladesch","Bangladesh"},
	{"BE","Belgien","Belgium"},
	{"BF","Burkina Faso","Burkina Faso"},
	{"BG","Bulgarien","Bulgaria"},
	{"BH","Bahrain","Bahrain"},
	{"BI","Burundi","Burundi"},
	{"BJ","Benin","Benin"},
	{"BM","die Bermudas","Bermuda"},
	{"BN","Brunei Darussalam","Brunei"},
	{"BO","Bolivien","Bolivia"},
	{"BR","Brasilien","Brazil"},
	{"BS","Bahamas","The Bahamas"},
	{"BT","Bhutan","Bhutan"},
	{"BV","Bouvetinsel","Bouvet Island"},
	{"BW","Botsuana","Botswana"},
	{"BY","Belarus","Belarus"},
	{"BZ","Belize","Belize"},
	{"CA","Kanada","Canada"},
	{"CC","Kokosinseln","Cocos (Keeling) Islands"},
	{"CD","Demokratische Republik Kongo","Democratic Republic of the Congo"},
	{"CF","Zentralafrikanische Republik","Central African Republic"},
	{"CG","Kongo","Congo"},
	{"CH","Schweiz","Switzerland"},
	{"CI","Cte d'Ivoire","Cte d'Ivoire"},
	{"CK","Cookinseln","Cook Islands"},
	{"CL","Chile","Chile"},
	{"CM","Kamerun","Cameroon"},
	{"CN","China","China"},
	{"CO","Kolumbien","Colombia"},
	{"CR","Costa Rica","Costa Rica"},
	{"CU","Kuba","Cuba"},
	{"CV","Kap Verde","Cape Verde"},
	{"CX","Weihnachtsinsel","Christmas Island"},
	{"CY","Zypern","Cyprus"},
	{"CZ","Tschechische Republik","Czech Republic"},
	{"DE","Deutschland","Germany"},
	{"DJ","Dschibuti","Djibouti"},
	{"DK","Dnemark","Denmark"},
	{"DM","Dominica","Dominica"},
	{"DO","Dominikanische Republik","Dominican Republic"},
	{"DZ","Algerien","Algeria"},
	{"EC","Ecuador","Ecuador"},
	{"EE","Estland","Estonia"},
	{"EG","gypten","Egypt"},
	{"EH","Westsahara","Western Sahara"},
	{"ER","Eritrea","Eritrea"},
	{"ES","Spanien","Spain"},
	{"ET","thiopien","Ethiopia"},
	{"FI","Finnland","Finland"},
	{"FJ","Fidschi","Fiji"},
	{"FK","Falklandinseln","Falkland Islands"},
	{"FM","Mikronesien","Micronesia"},
	{"FO","Frer","Faeroe Islands"},
	{"FR","Frankreich","France"},
	{"GA","Gabun","Gabon"},
	{"GB","Vereinigtes Knigreich","United Kingdom"},
	{"GD","Grenada","Grenada"},
	{"GE","Georgien","Georgia"},
	{"GF","Franzsisch-Guayana","French Guiana"},
	{"GH","Ghana","Ghana"},
	{"GI","Gibraltar","Gibraltar"},
	{"GL","Grnland","Greenland"},
	{"GM","Gambia","The Gambia"},
	{"GN","Guinea","Guinea"},
	{"GP","Guadeloupe","Guadeloupe"},
	{"GQ","quatorialguinea","Equatorial Guinea"},
	{"GR","Griechenland","Greece"},
	{"GS","Sdgeorgien und Sdliche Sandwichinseln","South Georgia and the South Sandwich Islands"},
	{"GT","Guatemala","Guatemala"},
	{"GU","Guam","Guam"},
	{"GW","Guinea-Bissau","Guinea-Bissau"},
	{"GY","Guyana","Guyana"},
	{"HK","Hongkong","Hong Kong"},
	{"HM","Heard und McDonaldinseln","Heard Island and McDonald Islands"},
	{"HN","Honduras","Honduras"},
	{"HR","Kroatien","Croatia"},
	{"HT","Haiti","Haiti"},
	{"HU","Ungarn","Hungary"},
	{"ID","Indonesien","Indonesia"},
	{"IE","Irland","Ireland"},
	{"IL","Israel","Israel"},
	{"IN","Indien","India"},
	{"IO","Britisches Territorium im Indischen Ozean","British Indian Ocean Territory"},
	{"IQ","Irak","Iraq"},
	{"IR","Iran","Iran"},
	{"IS","Island","Iceland"},
	{"IT","Italien","Italy"},
	{"JM","Jamaika","Jamaica"},
	{"JO","Jordanien","Jordan"},
	{"JP","Japan","Japan"},
	{"KE","Kenia","Kenya"},
	{"KG","Kirgisistan","Kyrgyzstan"},
	{"KH","Kambodscha","Cambodia"},
	{"KI","Kiribati","Kiribati"},
	{"KM","Komoren","Comoros"},
	{"KN","St. Kitts und Nevis","Saint Kitts and Nevis"},
	{"KP","Demokratische Volksrepublik Korea","North Korea"},
	{"KR","Republik Korea","South Korea"},
	{"KW","Kuwait","Kuwait"},
	{"KY","Kaimaninseln","Cayman Islands"},
	{"KZ","Kasachstan","Kazakhstan"},
	{"LA","Laos","Laos"},
	{"LB","Libanon","Lebanon"},
	{"LC","St. Lucia","Saint Lucia"},
	{"LI","Liechtenstein","Liechtenstein"},
	{"LK","Sri Lanka","Sri Lanka"},
	{"LR","Liberia","Liberia"},
	{"LS","Lesotho","Lesotho"},
	{"LT","Litauen","Lithuania"},
	{"LU","Luxemburg","Luxembourg "},
	{"LV","Lettland","Latvia"},
	{"LY","Libyen","Libya"},
	{"MA","Marokko","Morocco"},
	{"MC","Monaco","Monaco"},
	{"MD","Republik Moldau","Moldova"},
	{"MG","Madagaskar","Madagascar"},
	{"MH","Marshallinseln","Marshall Islands"},
	{"MK","ehemalige jugoslawische Republik Mazedonien","Former Yugoslav Republic of Macedonia"},
	{"ML","Mali","Mali"},
	{"MM","Myanmar","Myanmar"},
	{"MN","Mongolei","Mongolia"},
	{"MO","Macau","Macau"},
	{"MP","Nrdliche Marianen","Northern Marianas"},
	{"MQ","Martinique","Martinique"},
	{"MR","Mauretanien","Mauritania"},
	{"MS","Montserrat","Montserrat"},
	{"MT","Malta","Malta"},
	{"MU","Mauritius","Mauritius"},
	{"MV","Malediven","Maldives"},
	{"MW","Malawi","Malawi"},
	{"MX","Mexiko","Mexico"},
	{"MY","Malaysia","Malaysia"},
	{"MZ","Mosambik","Mozambique"},
	{"NA","Namibia","Namibia"},
	{"NC","Neukaledonien","New Caledonia"},
	{"NE","Niger","Niger"},
	{"NF","Norfolkinsel","Norfolk Island"},
	{"NG","Nigeria","Nigeria"},
	{"NI","Nicaragua","Nicaragua"},
	{"NL","Niederlande","Netherlands"},
	{"NO","Norwegen","Norway"},
	{"NP","Nepal","Nepal"},
	{"NR","Nauru","Nauru"},
	{"NU","Niue","Niue"},
	{"NZ","Neuseeland","New Zealand"},
	{"OM","Oman","Oman"},
	{"PA","Panama","Panama"},
	{"PE","Peru","Peru"},
	{"PF","Franzsisch-Polynesien","French Polynesia"},
	{"PG","Papua-Neuguinea","Papua New Guinea"},
	{"PH","Philippinen","Philippines"},
	{"PK","Pakistan","Pakistan"},
	{"PL","Polen","Poland"},
	{"PM","St. Pierre und Miquelon","Saint Pierre and Miquelon"},
	{"PN","Pitcairninseln","Pitcairn Islands"},
	{"PR","Puerto Rico","Puerto Rico"},
	{"PT","Portugal","Portugal"},
	{"PW","Palau","Palau"},
	{"PY","Paraguay","Paraguay"},
	{"QA","Katar","Qatar"},
	{"RE","Runion","Runion"},
	{"RO","Rumnien","Romania"},
	{"RU","Russische Fderation","Russia"},
	{"RW","Ruanda","Rwanda"},
	{"SA","Saudi-Arabien","Saudi Arabia"},
	{"SB","Salomonen","Solomon Islands"},
	{"SC","Seychellen","Seychelles"},
	{"SD","Sudan","Sudan"},
	{"SE","Schweden","Sweden"},
	{"SG","Singapur","Singapore"},
	{"SH","St. Helena","Saint Helena"},
	{"SI","Slowenien","Slovenia"},
	{"SJ","Svalbard und Jan Mayen","Svalbard and Jan Mayen"},
	{"SK","Slowakei","Slovakia"},
	{"SL","Sierra Leone","Sierra Leone"},
	{"SM","San Marino","San Marino"},
	{"SN","Senegal","Senegal"},
	{"SO","Somalia","Somalia"},
	{"SR","Suriname","Suriname"},
	{"ST","So Tom und Prncipe","So Tom and Prncipe"},
	{"SV","El Salvador","El Salvador"},
	{"SY","Syrien","Syria"},
	{"SZ","Swasiland","Swaziland"},
	{"TC","Turks- und Caicosinseln","Turks and Caicos Islands"},
	{"TD","Tschad","Chad"},
	{"TF","Franzsische Gebiete im sdlichen Indischen Ozean","French Southern Territories"},
	{"TG","Togo","Togo"},
	{"TH","Thailand","Thailand"},
	{"TJ","Tadschikistan","Tajikistan"},
	{"TK","Tokelau","Tokelau"},
	{"TL","Osttimor","East Timor"},
	{"TM","Turkmenistan","Turkmenistan"},
	{"TN","Tunesien","Tunisia"},
	{"TO","Tonga","Tonga"},
	{"TR","Trkei","Turkey"},
	{"TT","Trinidad und Tobago","Trinidad and Tobago"},
	{"TV","Tuvalu","Tuvalu"},
	{"TW","Taiwan","Taiwan"},
	{"TZ","Tansania","Tanzania"},
	{"UA","Ukraine","Ukraine"},
	{"UG","Uganda","Uganda"},
	{"UM","Kleinere amerikanische berseeinseln","United States Minor Outlying Islands"},
	{"US","Vereinigte Staaten","United States"},
	{"UY","Uruguay","Uruguay"},
	{"UZ","Usbekistan","Uzbekistan"},
	{"VA","Vatikanstadt","Vatican City"},
	{"VC","St. Vincent und die Grenadinen","Saint Vincent and the Grenadines"},
	{"VE","Venezuela","Venezuela"},
	{"VG","Britische Jungferninseln","British Virgin Islands"},
	{"VI","Amerikanische Jungferninseln","US Virgin Islands"},
	{"VN","Vietnam","Vietnam"},
	{"VU","Vanuatu","Vanuatu"},
	{"WF","Wallis und Futuna","Wallis and Futuna"},
	{"WS","Samoa","Samoa"},
	{"YE","Jemen","Yemen"},
	{"YT","Mayotte","Mayotte"},
	{"YU","Jugoslawien","Yugoslavia"},
	{"ZA","Sdafrika","South Africa"},
	{"ZM","Sambia","Zambia"},
	{"ZW","Simbabwe","Zimbabwe"}
		};

	static{
		countrynames = new ArrayList<String>();
		// extract english country names
		for (String[] country : countries) {
			countrynames.add(country[2]);
		}
		Collections.sort(countrynames);
	}

	public CountryServiceImpl() {
		final Logger logger = LoggerFactory.getLogger(CountryServiceImpl.class);
		logger.debug("constructed");
	}

	/**
	 * Returns a list of all country names
	 *
	 * @return
	 */
	public List<String> getAllCountryNames() {
		return Collections.unmodifiableList(countrynames);
	}

	/**
	 * Returns all countries starting with partial
	 *
	 * @param partial - beginning of the country name
	 * @return at least an empty List with matching country names
	 */
	public List<String> getCountryNamesByPartial(String partial) {
		List<String> result = new ArrayList<String>();
		for (String countryname : countrynames) {
			if(countryname.startsWith(partial))
				result.add(countryname);
		}
		return result;
	}
}
